summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorEric Blake <ebb9@byu.net>2009-10-17 07:55:05 -0600
committerEric Blake <ebb9@byu.net>2009-10-17 14:36:28 -0600
commit9e13b6a0b41532b63778aa67df40710df41174eb (patch)
treeb57f5cfb5452b54d42e3b81d25aa1bde32966bf2 /tests
parent527fb951def33fd76302e06f30e7221abd516ab6 (diff)
downloadcoreutils-9e13b6a0b41532b63778aa67df40710df41174eb.tar.xz
touch: add -h to change symlink timestamps, where supported
* src/touch.c (no_dereference): New flag variable. (longopts): Add -h/--no-dereference. (touch): Add symlink handling. (usage): Document new option. (main): Accept new option. * NEWS: Document it. * doc/coreutils.texi (touch invocation): Likewise. Also mention birthtime. * tests/touch/no-dereference: New test. * tests/Makefile.am (TESTS): Run it.
Diffstat (limited to 'tests')
-rw-r--r--tests/Makefile.am1
-rwxr-xr-xtests/touch/no-dereference80
2 files changed, 81 insertions, 0 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 8dc90f9f2..751db1cee 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -445,6 +445,7 @@ TESTS = \
touch/fail-diag \
touch/fifo \
touch/no-create-missing \
+ touch/no-dereference \
touch/no-rights \
touch/not-owner \
touch/obsolescent \
diff --git a/tests/touch/no-dereference b/tests/touch/no-dereference
new file mode 100755
index 000000000..28527e857
--- /dev/null
+++ b/tests/touch/no-dereference
@@ -0,0 +1,80 @@
+#!/bin/sh
+# Ensure that touch -h works.
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ touch --version
+fi
+
+. $srcdir/test-lib.sh
+
+ln -s nowhere dangling || framework_failure
+touch file || framework_failure
+ln -s file link || framework_failure
+
+fail=0
+
+# These first tests should work on every platform.
+# -h does not create files, but it warns. Use -c to silence warning.
+touch -h no-file 2> err && fail=1
+test -s err || fail=1
+touch -h -c no-file 2> err || fail=1
+test -s err && fail=1
+
+# -h works on regular files
+touch -h file || fail=1
+
+# -h coupled with -r uses timestamp of the symlink, not the referent.
+touch -h -r dangling file || fail=1
+test -f nowhere && fail=1
+
+# The remaining tests of -h require kernel support for changing symlink times.
+grep '^#define HAVE_UTIMENSAT' "$CONFIG_HEADER" > /dev/null ||
+grep '^#define HAVE_LUTIMES' "$CONFIG_HEADER" > /dev/null ||
+ skip_test_ 'this system lacks the utimensat function'
+
+# Changing time of dangling symlink is okay.
+touch -h dangling || fail=1
+test -f nowhere && fail=1
+
+# Change the mtime of a symlink.
+touch -m -h -d 2009-10-10 link || fail=1
+case `stat --format=%y link` in
+ 2009-10-10*) ;;
+ *) fail=1 ;;
+esac
+case `stat --format=%y file` in
+ 2009-10-10*) fail=1;;
+esac
+
+# Test interactions with -.
+touch -h - > file || fail=1
+
+test="$abs_top_builddir/src/test"
+
+# If >&- works, test "touch -ch -" etc.
+# >&- apparently does not work in HP-UX 11.23.
+# This test is ineffective unless /dev/stdout also works.
+# If stdout is open, it is not a symlink.
+if "$test" -w /dev/stdout >/dev/null &&
+ "$test" ! -w /dev/stdout >&-; then
+ touch -h - >&- && fail=1
+ touch -h -c - >&- || fail=1
+fi
+
+Exit $fail